(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
    (factory((global.react-taggy = global.react-taggy || {}),global.React));
}(this, function (exports,React) { 'use strict';

    React = 'default' in React ? React['default'] : React;

    var Taggy = function Taggy(_ref) {
        var text = _ref.text,
            spans = _ref.spans,
            ents = _ref.ents;

        console.log(spans);
        var jsx = [];
        if (typeof text === 'string') {
            var elements = [];
            var offset = 0;
            spans.forEach(function (_ref2) {
                var type = _ref2.type,
                    start = _ref2.start,
                    end = _ref2.end;

                var entity = text.slice(start, end);
                var fragment = text.slice(offset, start);
                elements.push(fragment);
                elements.push({
                    token: entity,
                    type: type.toLowerCase()
                });
                offset = end;
            });
            elements.push(text.slice(offset, text.length));
            elements = elements.filter(function (val) {
                return val !== ' ';
            });
            for (var e = 0; e < elements.length; e++) {
                if (elements[e].token) {
                    for (var i = e + 1; i < elements.length; i++) {
                        if (typeof elements[i] !== 'string' && elements[i].type === elements[e].type) {
                            elements[e].token += ' ' + elements[i].token;
                            elements[i] = false;
                        }
                        if (typeof elements[i] === 'string') {
                            break;
                        }
                    }
                }
            }
            elements = elements.filter(function (val) {
                return !!val;
            });
            elements.forEach(function (t) {
                if (typeof t === 'string') {
                    jsx.push(t);
                } else {
                    jsx.push(React.createElement(
                        'mark',
                        {
                            style: {
                                padding: '0.25em 0.35em',
                                margin: '0px 0.25em',
                                lineHeight: '1',
                                display: 'inline-block',
                                borderRadius: '0.25em',
                                border: '1px solid',
                                background: 'rgba(\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.r + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.g + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.b + ',\n                                0.2\n                            )',
                                borderColor: 'rgb(\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.r + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.g + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.b + '\n                            )'
                            }
                        },
                        t.token,
                        React.createElement(
                            'span',
                            {
                                style: {
                                    boxSizing: 'border-box',
                                    fontSize: '0.6em',
                                    lineHeight: '1',
                                    padding: '0.35em',
                                    borderRadius: '0.35em',
                                    textTransform: 'uppercase',
                                    display: 'inline-block',
                                    verticalAlign: 'middle',
                                    margin: '0px 0px 0.1rem 0.5rem',
                                    background: 'rgb(\n                                    ' + ents.find(function (ent) {
                                        return ent.type === t.type;
                                    }).color.r + ',\n                                    ' + ents.find(function (ent) {
                                        return ent.type === t.type;
                                    }).color.g + ',\n                                    ' + ents.find(function (ent) {
                                        return ent.type === t.type;
                                    }).color.b + '\n                                )'
                                }
                            },
                            t.type.toLowerCase()
                        )
                    ));
                }
            });
        }
        if (Array.isArray(text)) {
            var tokens = text;
            for (var s = 0; s < spans.length; s++) {
                tokens[spans[s].index] = {
                    token: tokens[spans[s].index],
                    type: spans[s].type.toLowerCase()
                };
            }
            for (var t = 0; t < tokens.length; t++) {
                if (tokens[t].token) {
                    for (var _i = t + 1; _i < tokens.length; _i++) {
                        if (typeof tokens[_i] !== 'string' && tokens[_i].type === tokens[t].type) {
                            tokens[t].token += ' ' + tokens[_i].token;
                            tokens[_i] = false;
                        }
                        if (typeof tokens[_i] === 'string') {
                            break;
                        }
                    }
                }
            }
            tokens = tokens.filter(function (val) {
                return !!val;
            });
            var tokensWithSpaces = tokens.map(function (t) {
                if (typeof t === 'string') {
                    return t + ' ';
                }
                return t;
            });
            tokensWithSpaces.forEach(function (t) {
                if (typeof t === 'string') {
                    jsx.push(t);
                } else {
                    jsx.push(React.createElement(
                        'mark',
                        {
                            style: {
                                padding: '0.25em 0.35em',
                                margin: '0px 0.25em',
                                lineHeight: '1',
                                display: 'inline-block',
                                borderRadius: '0.25em',
                                border: '1px solid',
                                background: 'rgba(\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.r + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.g + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.b + ',\n                                0.2\n                            )',
                                borderColor: 'rgb(\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.r + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.g + ',\n                                ' + ents.find(function (ent) {
                                    return ent.type === t.type;
                                }).color.b + '\n                            )'
                            }
                        },
                        t.token,
                        React.createElement(
                            'span',
                            {
                                style: {
                                    boxSizing: 'border-box',
                                    fontSize: '0.6em',
                                    lineHeight: '1',
                                    padding: '0.35em',
                                    borderRadius: '0.35em',
                                    textTransform: 'uppercase',
                                    display: 'inline-block',
                                    verticalAlign: 'middle',
                                    margin: '0px 0px 0.1rem 0.5rem',
                                    background: 'rgb(\n                                    ' + ents.find(function (ent) {
                                        return ent.type === t.type;
                                    }).color.r + ',\n                                    ' + ents.find(function (ent) {
                                        return ent.type === t.type;
                                    }).color.g + ',\n                                    ' + ents.find(function (ent) {
                                        return ent.type === t.type;
                                    }).color.b + '\n                                )'
                                }
                            },
                            t.type.toLowerCase()
                        )
                    ));
                }
            });
        }
        return React.createElement(
            'div',
            null,
            jsx.map(function (j, i) {
                return React.createElement(
                    'span',
                    { key: i },
                    j
                );
            })
        );
    };

    exports.Taggy = Taggy;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=index.umd.js.map